let worker;
let i = 0;
let cb = {};

export default (msg: any): Promise<any> => new Promise((res, rej) => {

  if (!worker) {
    worker = new Worker("build/workers/pixel-worker.js");
    worker.addEventListener("message", ev => {
      if (ev.data.i in cb) {
        cb[ev.data.i](ev.data.result);
      }
    })
  }

  i++;
  const _i = i;
  worker.postMessage({ i: _i, ...msg });
  cb[_i] = res;
});